Subject: Re: [Gen-art] Suggesting text for address prediction resistance (Was Re: DISCUSS and COMMENT: draft-krishnan-v6ops-teredo-update)

From: <[email-masked]>
Date: Thu, 3 Jun 2010 02:50:11 -0400

Suresh,

I like the overall approach taken in the text.  In B.1, the unknown IPv4 address is almost certainly not 32 bits of search space - the attacker probably knows which IPv4 address block is involved.  The same is probably true of Ethernet card vendor - the attacker probably has some good ideas of which vendors to check first, so that's probably not 24 bits of search space.  

What if you started with B.2, which is tightly written for the full-knowledge case, and then reasoned that lack of knowledge as one moves away from that scenario is likely to affect both the IPv4 address specificity and the Ethernet card vendor specificity in somewhat comparable fashions, suggesting that in typical cases, the search difficulties are likely to remain comparable, which was not the case before the 12 random bits were added?

The worst case would be an attacker who has found the Teredo gateway via its IPv4 address, but is completely clueless about the nature of the hosts behind it.  That seems odd - such an attacker could probably see the traffic emerging from the Teredo gateway and make some inferences about the sort of
hosts that are generating it.

Thanks,
--David

> -----Original Message-----
> From: Suresh Krishnan [mailto:[email-masked]]
> Sent: Wednesday, June 02, 2010 6:45 PM
> To: Russ Housley; Black, David; Tom Yu
> Cc: [email-masked]; [email-masked]; [email-masked]; draft-krishnan-v6ops-teredo-
> [email-masked]; Jari Arkko; Ralph Droms
> Subject: Suggesting text for address prediction resistance (Was Re: DISCUSS and COMMENT: draft-
> krishnan-v6ops-teredo-update)
> 
> Hi Russ/David/Tom,
>     I would like to propose some text for the resolving the DISCUSS
> position about quantifying the address prediction resistance of the
> Teredo address. Let me know if this works
> 
> * The following text will be added to the Security Considerations section.
> 
> "Appendix B compares the address prediction resistance of a Teredo
> address following this specification to that of an address formed using
> standard IPv6 Stateless Address Auto-configuration [RFC4862]."
> 
> * A new Appendix (B) will be added to provide the details
> 
> Appendix B. Resistance to address prediction
> 
>     This section compares the address prediction resistance of a Teredo
>     address as compared to an address formed using IPv6 stateless address
>     auto-configuration (SLAAC) [RFC4862] using two common scenarios.
> 
> B.1.  Attacker does not know Teredo Client's external IPv4 address or
>         Ethernet card vendor
> 
>     In this scenario the attacker does not know the Client's external
>     IPv4 address and has to search this space.  This gives us 32 bits of
>     search space.  In addition, the attacker does not know the external
>     port (16 bits) and the value of the random bits (12 bits).  This
>     gives the attacker a total search space of 60 bits (32+16+12).  This
>     compares very favorably with the 48 bits of search space required to
>     find an address configured using SLAAC (when Ethernet card's vendor
>     is not known) as described in Section 2.3 of [RFC5157].
> 
> B.2.  Attacker knows Teredo Client's external IPv4 address and Ethernet
>         card vendor
> 
>     In this scenario the attacker knows the Client's external IPv4
>     address and does not have to search this space.  The attacker does
>     not know the external port (16 bits) and the value of the random bits
>     (12 bits) and he has to search this space.  This gives the attacker a
>     total search space of 28 bits (16+12).  This compares very favorably
>     with the 24 bits of search space required to find an address
>     configured using SLAAC (when the Ethernet card's vendor is known) as
>     described in Section 2.3 of [RFC5157].
> 
> Cheers
> Suresh

---

From: Suresh Krishnan <[email-masked]>
Date: Thu, 3 Jun 2010 08:57:22 -0400

Hi David,
   I have rewritten Appendix B based on your suggestions. Does this work?

    This section compares the address prediction resistance of a Teredo
    address as compared to an address formed using IPv6 stateless address
    auto-configuration (SLAAC) [RFC4862].

    Let's assume that the attacker knows Teredo Client's external IPv4
    address and Ethernet card's vendor.  Since the attacker knows the
    Client's external IPv4 address he does not have to search this space.
    The attacker does not know the external port (16 bits) and the value
    of the random bits (12 bits) and he has to search this space.  This
    gives the attacker a total search space of 28 bits (16+12).  This
    compares very favorably with the 24 bits of search space required to
    find an address configured using SLAAC (when the Ethernet card's
    vendor is known) as described in Section 2.3 of [RFC5157].  Without
    the 12 random bits the search space is limited to only 16 bits and
    this is significantly worse than the 24 bits of search space provided
    by SLAAC.

    As the knowledge of the attacker decreases the number of bits of
    search space in both the cases is likely to increase in a relatively
    similar fashion.  The predictability of Teredo addresses will stay
    comparable to that of SLAAC addresses with the added 12 bits of
    search space, but will be significantly worse without the random
    bits

Thanks
Suresh

---

From: <[email-masked]>
Date: Thu, 3 Jun 2010 10:50:25 -0400

Yes, that's fine, and I see that it's in the submitted -09 version of
the draft.

Thanks,
--David

> From: [email-masked] [mailto:[email-masked]] On
Behalf Of Suresh Krishnan
> Sent: Thursday, June 03, 2010 8:57 AM
> To: Black, David
> Cc: [email-masked];
[email-masked];
[email-masked];
> [email-masked]; [email-masked]; [email-masked];
[email-masked]; [email-masked]
> Subject: Re: [Gen-art] Suggesting text for address prediction
resistance (Was Re: DISCUSS and COMMENT:
> draft-krishnan-v6ops-teredo-update)
> 
> Hi David,
> > I like the overall approach taken in the text.  In B.1, the unknown
IPv4 address is almost certainly
> not 32 bits of search space - the attacker probably knows which IPv4
address block is involved.  The
> same is probably true of Ethernet card vendor - the attacker probably
has some good ideas of which
> vendors to check first, so that's probably not 24 bits of search
space.
> >
> > What if you started with B.2, which is tightly written for the
full-knowledge case, and then
> reasoned that lack of knowledge as one moves away from that scenario
is likely to affect both the IPv4
> address specificity and the Ethernet card vendor specificity in
somewhat comparable fashions,
> suggesting that in typical cases, the search difficulties are likely
to remain comparable, which was
> not the case before the 12 random bits were added?
> >
> > The worst case would be an attacker who has found the Teredo gateway
via its IPv4 address, but is
> completely clueless about the nature of the hosts behind it.  That
seems odd - such an attacker could
> probably see the traffic emerging from the Teredo gateway and make
some inferences about the sort of
> >> Cc: [email-masked]; [email-masked];
[email-masked]; draft-krishnan-v6ops-teredo-
> _______________________________________________
> Gen-art mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/gen-art